//////////////////////////////
// Player dispatcher class for CADET
// NOTE: refactored without classes, since IE doesn't support classes
//////////////////////////////
/**/

var PDEditor;
var PlayerDispatch = {};

PlayerDispatch.setEditor=function(editor){
	PDEditor = editor;
	PlayerDispatch.editor = editor;
}//setEditor

PlayerDispatch.getEditor=function(){
	return PlayerDispatch.editor;
}//getEditor

PlayerDispatch.showPlayer=function(type) {
	var ret = null;
	
	//tear down any wavesurfer
	if( mywavesurfer ){
		mywavesurfer.teardown();
		mywavesurfer = null;
	}
	
	switch(mediaLocationType){
		case MEDIA_LOCATION_LOCAL:
			//unshow vimeo player
			$("#cadetplayerRemote").css("display","none"); //hide remote div
			$("#remoteSubstitute").css("display","none"); //hide VIMEO player

			//unshow youtube player
			$("#cadetplayerRemote").css("display","none"); //hide remote div
			$("#remoteSubstituteYT").css("display","none"); //hide YOUTUBE player

			//unshow facebook player
			$("#cadetplayerRemote").css("display","none"); //hide remote div
			$("#remoteSubstituteFB").css("display","none"); //hide FACEBOOK player

			//unshow generic player
			$("#cadetplayerRemote").css("display","none"); //hide remote div
			$("#remoteSubstituteGeneric").css("display","none"); //hide generic player

			//show local player
			$("#cadetplayerLocal").css("display",""); //show local player
			break;

		case MEDIA_LOCATION_YT:
			//add .ccouter on cadetPlayerRemote
			//$("#cadetplayerRemote").addClass("ccouter");
			
			//hide local player
			$("#cadetvideo")[0].src="";
			var trk=$("#cadetvideo > track")[0];
			trk.src="";
			$("#cadetplayerLocal").css("display","none"); //hide local player

			//hide vimeo player
			$("#cadetplayerRemote").css("display","none"); //hide remote div
			$("#remoteSubstitute").css("display","none"); //hide VIMEO player

			//unshow facebook player
			$("#cadetplayerRemote").css("display","none"); //hide remote div
			$("#remoteSubstituteFB").css("display","none"); //hide FACEBOOK player

			//hide generic player
			$("#cadetplayerRemote").css("display","none"); //hide remote div
			$("#remoteSubstituteGeneric").css("display","none"); //hide generic player

			//show youtube player
			$("#cadetplayerRemote").css("display",""); //show remote div
			$("#remoteSubstituteYT").css("display",""); //show YOUTUBE player
			//and player div needs a size, not just 100%, so...
			//$("#cadetplayer").css({'width':'644px','height':'auto'});
			//$("#cadetplayerRemote").css({'width':'640px','height':'390px'});
			$("#cadetplayer").css({'width':'100%','height':'auto'});
			$("#cadetplayerRemote").css({'width':'100%','height':'50vmin'});
			
			break;

		case MEDIA_LOCATION_FACEBOOK:
			//add .ccouter on cadetPlayerRemote
			//$("#cadetplayerRemote").addClass("ccouter");
			
			//hide local player
			$("#cadetvideo")[0].src="";
			var trk=$("#cadetvideo > track")[0];
			trk.src="";
			$("#cadetplayerLocal").css("display","none"); //hide local player

			//hide vimeo player
			$("#cadetplayerRemote").css("display","none"); //hide remote div
			$("#remoteSubstitute").css("display","none"); //hide VIMEO player

			//hide generic player
			$("#cadetplayerRemote").css("display","none"); //hide remote div
			$("#remoteSubstituteGeneric").css("display","none"); //hide generic player

			//unshow youtube player
			$("#cadetplayerRemote").css("display","none"); //hide remote div
			$("#remoteSubstituteYT").css("display","none"); //hide YOUTUBE player

			//show youtube player
			$("#cadetplayerRemote").css("display",""); //show remote div
			$("#remoteSubstituteFB").css("display",""); //show FACEBOOK player
			//and player div needs a size, not just 100%, so...
			//$("#cadetplayer").css({'width':'644px','height':'auto'});
			//$("#cadetplayerRemote").css({'width':'640px','height':'390px'});
			$("#cadetplayer").css({'width':'100%','height':'auto'});
			$("#cadetplayerRemote").css({'width':'100%','height':'50vmin'});
			
			break;
			
		case MEDIA_LOCATION_VIMEO:
			//add .ccouter on cadetPlayerRemote
			//$("#cadetplayerRemote").addClass("ccouter");
		
			//hide local player
			$("#cadetvideo")[0].src="";
			var trk=$("#cadetvideo > track")[0];
			trk.src="";
			$("#cadetplayerLocal").css("display","none"); //hide local player

			//hide youtube player
			$("#cadetplayerRemote").css("display","none"); //hide remote div
			$("#remoteSubstituteYT").css("display","none"); //hide YOUTUBE player

			//unshow facebook player
			$("#cadetplayerRemote").css("display","none"); //hide remote div
			$("#remoteSubstituteFB").css("display","none"); //hide FACEBOOK player

			//hide generic player
			$("#cadetplayerRemote").css("display","none"); //hide remote div
			$("#remoteSubstituteGeneric").css("display","none"); //hide generic player

			//show vimeo player
			$("#cadetplayerRemote").css("display",""); //show remote div
			$("#remoteSubstitute").css("display",""); //show VIMEO player
			//and player div needs a size, not just 100%, so...
			//$("#cadetplayer").css({'width':'644px','height':'auto'});
			//$("#cadetplayerRemote").css({'width':'640px','height':'390px'});
			$("#cadetplayer").css({'width':'100%','height':'auto'});
			$("#cadetplayerRemote").css({'width':'100%','height':'50vmin'});
			
			break;
			
		case MEDIA_LOCATION_GENERIC_REMOTE:
			//alert("player0:showPlayer: generic remote called");
		
			//hide local player
			$("#cadetvideo")[0].src="";
			var trk=$("#cadetvideo > track")[0];
			trk.src="";
			$("#cadetplayerLocal").css("display","none"); //hide local player

			//hide youtube player
			$("#cadetplayerRemote").css("display","none"); //hide remote div
			$("#remoteSubstituteYT").css("display","none"); //hide VIMEO player

			//unshow facebook player
			$("#cadetplayerRemote").css("display","none"); //hide remote div
			$("#remoteSubstituteFB").css("display","none"); //hide FACEBOOK player

			//hide vimeo player
			$("#cadetplayerRemote").css("display","none"); //hide remote div
			$("#remoteSubstitute").css("display","none"); //hide VIMEO player

			//show generic player
			$("#cadetplayerRemote").css("display",""); //show remote div
			$("#remoteSubstituteGeneric").css("display",""); //show VIMEO player
			break;
			
		default:
			ret = null;
			break;
	}//switch
}//showPlayer

PlayerDispatch.loadRemoteVideo=function(vidid) {
	//alert("PlayerDispatch loadRemoteVideo vidid=["+vidid+"]");
	var ret = null;
	switch(mediaLocationType){
		case MEDIA_LOCATION_YT:
			ret = YTplayer ? YTplayer.loadVideo(vidid) : null;
			break;
		case MEDIA_LOCATION_VIMEO:
			ret = VimeoPlayer ? VimeoPlayer.loadVideo(vidid) : null;
			break;
		case MEDIA_LOCATION_FACEBOOK:
			ret = FacebookPlayer ? FacebookPlayer.loadVideo(vidid) : null;
			break;
		case MEDIA_LOCATION_GENERIC_REMOTE:
			ret = GenericRemotePlayer ? GenericRemotePlayer.loadVideo(vidid) : null;
			break;
		default:
			ret = null;
		break;
	}//switch
	this.editor.justFocusCaptionCell(0);
}//loadRemoteVideo

PlayerDispatch.unloadRemoteVideo=function() {
	var ret = null;
	switch(mediaLocationType){
		case MEDIA_LOCATION_YT:
			YTplayer.unloadVideo();
			break;
		case MEDIA_LOCATION_VIMEO:
			VimeoPlayer.unloadVideo();
			break;
		case MEDIA_LOCATION_GENERIC_REMOTE:
			GenericRemotePlayer.unloadVideo();
			break;
		default:
			ret = null;
			break;
	}//switch
}//unloadRemoteVideo

PlayerDispatch.playerGetTime=function() {
	var ret = 0.0;
	switch(mediaLocationType){
		case MEDIA_LOCATION_LOCAL:
			ret = this.editor.getMediaTime(); //$("video")[0].currentTime;
			break;
		case MEDIA_LOCATION_YT:
			ret = YTplayer ? YTplayer.getTime() : 0.0;
			break;
		case MEDIA_LOCATION_VIMEO:
			ret = VimeoPlayer ? VimeoPlayer.getTime() : 0.0;
			break;
		case MEDIA_LOCATION_FACEBOOK:
			ret = FacebookPlayer ? FacebookPlayer.getTime() : 0.0;
			break;
		case MEDIA_LOCATION_GENERIC_REMOTE:
			ret = GenericRemotePlayer ? GenericRemotePlayer.getTime() : 0.0;
			break;
		default:
			ret = 0.0
			break;
	}//switch
	return ret;
}//playerGetTime

PlayerDispatch.displayCaptions=function(b) {
	var ret = b;
	switch(mediaLocationType){
		case MEDIA_LOCATION_LOCAL:
			var v = document.getElementById("cadetvideo")
			v.textTracks[0].mode = b ? "showing" : "hidden";  // "showing"/"hidden"
			break;
		case MEDIA_LOCATION_YT:
			ccDisplay.enableCC(b);
			break;
		case MEDIA_LOCATION_VIMEO:
			ccDisplay.enableCC(b);
			break;
		case MEDIA_LOCATION_GENERIC_REMOTE:
			ccDisplay.enableCC(b);
			break;
		default:
			break;
	}//switch
	return ret;
}//displayCaptions

PlayerDispatch.setPlayerSpeed=function(x){
	switch(mediaLocationType){
		case MEDIA_LOCATION_LOCAL:
			this.editor.setPlayerSpeed(x);
			break;
		case MEDIA_LOCATION_YT:
			YTplayer.setPlayerSpeed(x);
			break;
		case MEDIA_LOCATION_VIMEO:
			VimeoPlayer.setPlayerSpeed(x);
			break;
		case MEDIA_LOCATION_GENERIC_REMOTE:
			GenericRemotePlayer.setPlayerSpeed(x);
			break;
		default:
			break;
	}//switch
}//setPlayerSpeed

PlayerDispatch.playerIsPaused=function(){
	switch(mediaLocationType){
		case MEDIA_LOCATION_LOCAL:
			return this.editor.playerIsPaused();
			break;
		case MEDIA_LOCATION_YT:
			return YTplayer.isPaused();
			break;
		case MEDIA_LOCATION_VIMEO:
			return VimeoPlayer.isPaused(); //VimeoPlayer.isPaused();  //FIGURE OUT THE PROMISE THING!!
			break;
		case MEDIA_LOCATION_GENERIC_REMOTE:
			return GenericRemotePlayer.isPaused();
			break;
		default:
			break;
	}//switch
	return false;
}//playerIsPaused

PlayerDispatch.playerPlay=function(){
	switch(mediaLocationType){
		case MEDIA_LOCATION_LOCAL:
			return this.editor.playMedia();
			break;
		case MEDIA_LOCATION_VIMEO:
			VimeoPlayer.play();
			break;
		case MEDIA_LOCATION_FACEBOOK:
			FacebookPlayer.playMedia();
			break;
		case MEDIA_LOCATION_GENERIC_REMOTE:
			GenericRemotePlayer.play();
			break;
		default:
			break;
	}//switch
	return;
}//playerPlay

PlayerDispatch.playerPause=function(){
	switch(mediaLocationType){
		case MEDIA_LOCATION_LOCAL:
			return this.editor.pauseMedia();
			break;
		case MEDIA_LOCATION_VIMEO:
			VimeoPlayer.pause();
			break;
		case MEDIA_LOCATION_FACEBOOK:
			FacebookPlayer.pauseMedia();
			break;
		case MEDIA_LOCATION_GENERIC_REMOTE:
			GenericRemotePlayer.pause();
			break;
		default:
			break;
	}//switch
	return;
}//playerPause

PlayerDispatch.playerPlayPause=function(editor) {
	switch(mediaLocationType){
		case MEDIA_LOCATION_LOCAL:
			this.editor.playPauseMedia();
			break;
		case MEDIA_LOCATION_YT:
			YTplayer.playPauseMedia();
			break;
		case MEDIA_LOCATION_VIMEO:
			VimeoPlayer.playPauseMedia();
			break;
		case MEDIA_LOCATION_FACEBOOK:
			FacebookPlayer.playPauseMedia();
			break;
		case MEDIA_LOCATION_GENERIC_REMOTE:
			GenericRemotePlayer.playPauseMedia();
			break;
		default:
			break;
	}//switch
	return;
}//playerPlayPause

PlayerDispatch.playerPlayPauseSpecial=function(editor) {
	switch(mediaLocationType){
		case MEDIA_LOCATION_LOCAL:
			this.editor.playPauseSpecial();
			break;
		case MEDIA_LOCATION_YT:
			YTplayer.playPauseMediaSpecial();
			break;
		case MEDIA_LOCATION_VIMEO:
			VimeoPlayer.playPauseMediaSpecial();
			break;
		case MEDIA_LOCATION_FACEBOOK:
			FacebookPlayer.playPauseMediaSpecial();
			break;
		case MEDIA_LOCATION_GENERIC_REMOTE:
			GenericRemotePlayer.playPauseMediaSpecial();
			break;
		default:
			break;
	}//switch
	return;
}//playerPlayPauseSpecial

PlayerDispatch.cueMedia=function(s) {
	switch(mediaLocationType){
		case MEDIA_LOCATION_LOCAL:
			this.editor.cueMedia(s);
			break;
		case MEDIA_LOCATION_YT:
			YTplayer.cueMedia(s);
			break;
		case MEDIA_LOCATION_VIMEO:
			VimeoPlayer.cueMedia(s);
			break;
		case MEDIA_LOCATION_FACEBOOK:
			FacebookPlayer.cueMedia(s);
			break;
		case MEDIA_LOCATION_GENERIC_REMOTE:
			GenericRemotePlayer.cueMedia(s);
			break;
		default:
			break;
	}//switch
	return;
}//cueMedia

PlayerDispatch.requestFullScreen=function() {
	launchIntoFullscreen(document.getElementById("cadetplayerwrapper"));
	return;
	switch(mediaLocationType){
		case MEDIA_LOCATION_LOCAL:
			launchIntoFullscreen(document.getElementById("cadetvideo"));
			break;

		case MEDIA_LOCATION_YT:
			launchIntoFullscreen(document.getElementById("cadetplayerRemote"));
			break;

		case MEDIA_LOCATION_VIMEO:
			launchIntoFullscreen(document.getElementById("cadetplayerRemote"));
			break;

		case MEDIA_LOCATION_GENERIC_REMOTE:
			launchIntoFullscreen(document.getElementById("genericRemoteVideo"));
			break;

		default:
			break;
	}//switch
	return;
}//requestFullScreen

PlayerDispatch.resizePlayerObject=function(w,h){
	switch(mediaLocationType){
		case MEDIA_LOCATION_LOCAL:
			//debug("PLAYER0: resizePlayerObject local");
			if( w===undefined ){
			//debug("PLAYER0: resizePlayerObject local 100%");
			$("#cadetvideo").css({"top":"0px", "left":"0px", "width":"100%", "height":"100%"});
			} else {
			//debug("PLAYER0: resizePlayerObject local w=["+w+"] h=["+h+"]");
			$("#cadetvideo").css({"top":"0px", "left":"0px", "height":h.toString()+"px", "width":w.toString()+"px"});
			}
			break;
			
		case MEDIA_LOCATION_YT:
			//debug("PLAYER0: resizePlayerObject YT");
			var isFullScreen = document.fullScreen || document.mozFullScreen || document.webkitIsFullScreen || (document.msFullscreenElement != null);
			if( isFullScreen ){    //fullscreen size
			$("#cadetplayerRemote").css({"top":"0px", "left":"0px", "width":"100%", "height":"100%", "position":"absolute"});
			if( YTplayer.player )
			YTplayer.player.setSize(1920,1024);
			} else {
			$("#cadetplayerRemote").css({"top":"0px", "left":"0px", "position":"relative"});
			if( YTplayer.player )
			YTplayer.player.setSize(oldOuterWidth,oldOuterHeight);
			}
			break;
			
		case MEDIA_LOCATION_VIMEO:
			//debug("PLAYER0: resizePlayerObject VIMEO");
			var isFullScreen = document.fullScreen || document.mozFullScreen || document.webkitIsFullScreen || (document.msFullscreenElement != null);
			if( isFullScreen ){    //fullscreen size
				$("#cadetplayerRemote").css({"top":"0px", "left":"0px", "width":"100%", "height":"100%", "position":""});
				if( VimeoPlayer.player ){
					//VimeoPlayer.player.setSize(1920,1024);
					//$("#remoteSubstitute > iframe").css({"height":"100%"});
					var when = PlayerDispatch.playerGetTime();
					VimeoPlayer.createPlayer(mediaUrl,$(document).width(),$(document).height(),when);
					if( !PlayerDispatch.playerIsPaused() ){ //get current playhead and keep playing from there
						PlayerDispatch.playerPlayPause();
					}
					PlayerDispatch.cueMedia(when);
				}
			} else {
				//$("#cadetplayerRemote").css({"top":"0px", "left":"0px", "position":"relative"});
				if( VimeoPlayer.player ){
					//VimeoPlayer.player.setSize(oldOuterWidth,oldOuterHeight);
					var when = PlayerDispatch.playerGetTime();
					var wasPaused = PlayerDispatch.playerIsPaused();
					VimeoPlayer.createPlayer(mediaUrl,oldOuterWidth,oldOuterHeight);
					if( !wasPaused ){ //get current playhead and keep playing from there
						PlayerDispatch.cueMedia(when);
						PlayerDispatch.playerPlay();
					} else {
						PlayerDispatch.cueMedia(when);
						//VimeoPlayer.player.play();
						//VimeoPlayer.player.pause();
					}
				}//VimeoPlayer.player
			}//isFullScreen

		case MEDIA_LOCATION_GENERIC_REMOTE:
		/*
			//debug("PLAYER0: resizePlayerObject local");
			if( w===undefined ){
			//debug("PLAYER0: resizePlayerObject local 100%");
				$("#genericRemoteVideo").css({"top":"0px", "left":"0px", "width":"100%", "height":"100%"});
			} else {
			//debug("PLAYER0: resizePlayerObject local w=["+w+"] h=["+h+"]");
			$("#genericRemoteVideo").css({"top":"0px", "left":"0px", "height":h.toString()+"px", "width":w.toString()+"px"});
			}
			break;
		*/	
		default:
			break;
	}//switch
	return;
}//resizePlayerObject

PlayerDispatch.renderCurrentCaption=function(){
	//debug("PlayerDispatch: renderCurrentCaption");
	this.editor.renderIthCaption(); //leave out the parameter to get current caption
}//renderCurrentCaption

PlayerDispatch.renderIthCaption=function(i){
	//debug("PlayerDispatch: renderIthCaption");
	this.editor.renderIthCaption(i);
}//renderIthCaption

PlayerDispatch.setUItime=function(n){
	var value = n;
	var svalue = (typeof value !== 'undefined')?value.toTimecode():"";
	$("#mediatime")[0].value = svalue;
}//setUItime

PlayerDispatch.dragResizePlayer=function(w,h){
	switch(mediaLocationType){
		case MEDIA_LOCATION_LOCAL:
		case MEDIA_LOCATION_GENERIC_REMOTE:
			break;
		
			var ifoo = $("#localProjectFile").height() + $("#localMediaFile").height() + $("#playSpeedDiv").height() + $("#cadetvideo").height()+ $("#resizerplayer").height() + 9;
			$("#cadetplayer").css('height', ifoo +"px");
			break;

		case MEDIA_LOCATION_YT:
			//$("#cadetplayer").css('height', h +"px");
			YTplayer.resizePlayer(w,h);
			break;

		case MEDIA_LOCATION_VIMEO:
			$("#cadetplayerRemote").css({"top":"0px", "left":"0px", "width":"100%", "height":"100%", "position":""});
			$("#remoteSubstitute").css({"width":w+"px", "height":h+"px"})
			if( VimeoPlayer.player ){
			VimeoPlayer.createPlayer(mediaUrl,w,h);
			}
			break;

		case MEDIA_LOCATION_GENERIC_REMOTE:
			var ifoo = $("#localProjectFile").height() + $("#localMediaFile").height() + $("#playSpeedDiv").height() + $("#genericRemoteVideo").height()+ $("#resizerplayer").height() + 9;
			$("#cadetplayer").css('height', ifoo +"px");
			break;

		default:
			break;
	}//switch

	PlayerDispatch.editor.focusCurrentRowCaptionCell();
	return;
}//dragResizePlayer

PlayerDispatch.mediaJump=function(bhow, inc){
	switch(mediaLocationType){
		case MEDIA_LOCATION_LOCAL:
		this.editor.mediaJump(bhow, inc);
		break;

	case MEDIA_LOCATION_YT:
		if( YTplayer.player )
		YTplayer.mediaJump(bhow, inc);
		break;

	case MEDIA_LOCATION_VIMEO:
		if( VimeoPlayer.player )
		VimeoPlayer.mediaJump(bhow, inc);
		break;

	case MEDIA_LOCATION_FACEBOOK:
		if( FacebookPlayer.player )
		FacebookPlayer.mediaJump(bhow, inc);
		break;

	default:
		break;
	}//switch
	return;
}//mediaJump

